clear all;
format long;

%Dane pomiarowe
x=[1 2 3 4 5 6 7 8 9 10];
y=[0.9 5 4.1 8.2 5.9 8.1 12.4 12 12.7 16.3];

%Wyznaczenie niepewnoci pomiarw
dx=(((0.01).*x)./100+0.2);
%dx(2)=0.01;
%dy=(((0.05).*y)./100+0.05);
dy=sqrt(y); dy(1)=1;
dy(2)=0.9;  %Jest prosta
%dy(2)=0.5; %Nie ma prostej 

%Aproksymacja liniowa
[P,SP]=linfitxy(x,y,dx,dy,'Plotting',false,'Verbosity',false);
%[P,SP]=linfitxy(x,y,dx,dy);

%Dane
figure;
plot(x,y,'xb',...
    'LineWidth',2,...
    'MarkerSize',10,...
    'MarkerEdgeColor','b',...
    'MarkerFaceColor',[0.7,0.7,0.7])
hold on;

%Proste
xl=1:0.1:length(x);
ylN=P(1)*xl+P(2);
ymin=(P(1)-SP(1))*xl+(P(2)-SP(2));
ymax=(P(1)+SP(1))*xl+(P(2)+SP(2));

%Dorysowanie prostych regresji
%Prosta rodkowa pokrywa si z prost aproksymacji
plot(xl,ylN,'y');
plot(xl,ymin,'b');
plot(xl,ymax,'g');

%Wykresy obszarw bdw
for i=1:length(x)
     line([x(i)-dx(i),x(i)-dx(i)],[y(i)-dy(i),y(i)+dy(i)]);
     line([x(i)-dx(i),x(i)+dx(i)],[y(i)+dy(i),y(i)+dy(i)]);
     line([x(i)+dx(i),x(i)+dx(i)],[y(i)+dy(i),y(i)-dy(i)]);
     line([x(i)+dx(i),x(i)-dx(i)],[y(i)-dy(i),y(i)-dy(i)]);
end 
grid;

fprintf('     Wspczynnik K ley w przedziale: \n%5.3f do %5.3f\n',P(1)-SP(1),P(1)+SP(1));
fprintf('     Warto wspczynnika wynosi: \n%5.3f\n',P(1));
fprintf('     Cisnienie wyznaczamy z zalenioci: \nP=(1/K)*U\n');

