clear all;
format long;

%Konieczne wprowadzenie bdu aprioksymacji
eps=1*10^-10;

%Dane pomiarowe
x=[1 2 3 4 5 6 7 8 9 10];
y=[0.9 5+3 4.1 8.2 5.9 8.1 12.4 12 12.7 16.3];

%Wyznaczenie niepewnoci pomiarw
dx=(((0.01).*x)./100+0.2);
%dx(2)=0.01;
%dy=(((0.05).*y)./100+0.05);
dy=sqrt(y); dy(1)=1;
dy(2)=0.9;  %Jest prosta
%dy(2)=0.5; %Nie ma prostej 

%Aproksymacja liniowa
P=polyfit(x,y,1);

%Wykres prostej aproksymacyjnej
figure;
xl=1:0.1:10;
yl=P(1)*xl+P(2);
plot(xl,yl,'r');
grid
hold on;
plot(x,y,'xb',...
    'LineWidth',2,...
    'MarkerSize',10,...
    'MarkerEdgeColor','b',...
    'MarkerFaceColor',[0.7,0.7,0.7])

%Obszary bdw
for i=1:length(x)
     line([x(i)-dx(i),x(i)-dx(i)],[y(i)-dy(i),y(i)+dy(i)]);
     line([x(i)-dx(i),x(i)+dx(i)],[y(i)+dy(i),y(i)+dy(i)]);
     line([x(i)+dx(i),x(i)+dx(i)],[y(i)+dy(i),y(i)-dy(i)]);
     line([x(i)+dx(i),x(i)-dx(i)],[y(i)-dy(i),y(i)-dy(i)]);
end 

%Proste skrajne punkty
%line([x(1)-dx(1),x(length(x))+dx(length(x))],[y(1)+dy(1),y(length(x))-dy(length(x))]);
%line([x(2)+dx(2),x(length(x)-1)-dx(length(x)-1)],[y(2)-dy(2),y(length(x)-1)+dy(length(x)-1)]);
%line([x(1)+dx(1),x(length(x))-dx(length(x))],[y(1)-dy(1),y(length(x))+dy(length(x))]);

%Wyznaczenie naronikw
N=length(x);
aKmin=inf;
aKmax=-inf;
bKmin=0;
bKmax=0;
iKmin=0;
iKmax=0;
jKmin=0;
jKmax=0;
for i=1:N
    for j=i+1:N
        %Wyznaczenie prostych
        amin=((y(j)-dy(j))-(y(i)+dy(i)))/((x(j)+dx(j))-(x(i)-dx(i)));
        bmin=(y(i)+dy(i))-amin*(x(i)-dx(i));

        amax=((y(j)+dy(j))-(y(i)-dy(i)))/((x(j)-dx(j))-(x(i)+dx(i)));
        bmax=(y(i)-dy(i))-amax*(x(i)+dx(i));
        
        %Sprawdzenie pokrycia obszarw 
        OKmin=1;
        OKmax=1;
%if i==2 & j==5
%xl=x(1):x(N)/10:N;
%ylmin=amin*xl+bmin;
%ylmax=amax*xl+bmax;
%plot(xl,ylmin,'g');
%plot(xl,ylmax,'y');              
%end
        for k=1:N 
            w1=amin*(x(k)-dx(k))+bmin;
            w2=amin*(x(k)+dx(k))+bmin;
            if( ((( y(k)-dy(k) ) > (w1+eps) ) | ( (w1-eps) > ( y(k)+dy(k) ))) & ... %Lezy poza przedziaami
               ((( y(k)-dy(k) ) > (w2+eps) ) | ( (w2-eps) > ( y(k)+dy(k) )))   )
               OKmin=0;  
            end
            w1=amax*(x(k)-dx(k))+bmax;
            w2=amax*(x(k)+dx(k))+bmax;
            if( ((( y(k)-dy(k) ) > (w1+eps)) | ( (w1-eps) > ( y(k)+dy(k) ))) & ... %Lezy poza przedziaami
               ((( y(k)-dy(k) ) > (w2+eps)) | ( (w1-eps) > ( y(k)+dy(k) )))   )
                OKmax=0;            
            end       
        end 
    
        %Sprawdzenie wikszoi mniejszosci
        if ( OKmin==1 ) & ( amin < aKmin )
            aKmin = amin;
            bKmin = bmin;
            iKmin=i;
            jKmin=j;
        end
        if ( OKmax==1 ) & ( amax > aKmax )
            aKmax = amax;
            bKmax = bmax;
            iKmax=i;
            jKmax=j;
        end
    end
end

if iKmin==0 | iKmax==0 | jKmin==0 | jKmax==0
    disp('     Nie ma prostej przechodzacej przez wszystkie obszary');
else
    xl=x(1):x(N)/10:N;
    ylmin=aKmin*xl+bKmin;
    ylmax=aKmax*xl+bKmax;

    plot(xl,ylmin,'y');
    plot(xl,ylmax,'b');
    
    fprintf('     Wspczynnik K ley w przedziale: \n%5.3f do %5.3f\n',aKmin,aKmax);
    fprintf('     Warto wspczynnika wynosi: \n%5.3f\n',P(1));
    fprintf('     Cisnienie wyznaczamy z zalenioci: \nP=(1/K)*U\n');
end
